加载中...
11-盛最多水的容器(Container With Most Water)
发表于:2021-12-03 | 分类: 中等
字数统计: 1.1k | 阅读时长: 5分钟 | 阅读量:

原文链接: https://leetcode-cn.com/problems/container-with-most-water

英文原文

Given n non-negative integers a1, a2, ..., an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of the line i is at (i, ai) and (i, 0). Find two lines, which, together with the x-axis forms a container, such that the container contains the most water.

Notice that you may not slant the container.

 

Example 1:

Input: height = [1,8,6,2,5,4,8,3,7]
Output: 49
Explanation: The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49.

Example 2:

Input: height = [1,1]
Output: 1

Example 3:

Input: height = [4,3,2,1,4]
Output: 16

Example 4:

Input: height = [1,2,1]
Output: 2

 

Constraints:

  • n == height.length
  • 2 <= n <= 105
  • 0 <= height[i] <= 104

中文题目

给你 n 个非负整数 a1,a2,...,an每个数代表坐标中的一个点 (i, ai) 。在坐标内画 n 条垂直线,垂直线 i 的两个端点分别为 (i, ai)(i, 0) 。找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水。

说明:你不能倾斜容器。

 

示例 1:

输入:[1,8,6,2,5,4,8,3,7]
输出:49 
解释:图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7]。在此情况下,容器能够容纳水(表示为蓝色部分)的最大值为 49。

示例 2:

输入:height = [1,1]
输出:1

示例 3:

输入:height = [4,3,2,1,4]
输出:16

示例 4:

输入:height = [1,2,1]
输出:2

 

提示:

  • n == height.length
  • 2 <= n <= 105
  • 0 <= height[i] <= 104

通过代码

高赞题解

设两指针 $i$ , $j$ ,指向的水槽板高度分别为 $h[i]$ , $h[j]$ ,此状态下水槽面积为 $S(i, j)$ 。由于可容纳水的高度由两板中的 短板 决定,因此可得如下 面积公式

$$

S(i, j) = min(h[i], h[j]) × (j - i)

$$

Picture0.png{:width=500}

在每个状态下,无论长板或短板向中间收窄一格,都会导致水槽 底边宽度 $-1$​ 变短:

  • 若向内 移动短板 ,水槽的短板 $min(h[i], h[j])$ 可能变大,因此下个水槽的面积 可能增大

  • 若向内 移动长板 ,水槽的短板 $min(h[i], h[j])$​ 不变或变小,因此下个水槽的面积 一定变小

因此,初始化双指针分列水槽左右两端,循环每轮将短板向内移动一格,并更新面积最大值,直到两指针相遇时跳出;即可获得最大面积。

算法流程:

  1. 初始化: 双指针 $i$ , $j$ 分列水槽左右两端;

  2. 循环收窄: 直至双指针相遇时跳出;

    1. 更新面积最大值 $res$ ;

    2. 选定两板高度中的短板,向中间收窄一格;

  3. 返回值: 返回面积最大值 $res$ 即可;

正确性证明:

若暴力枚举,水槽两板围成面积 $S(i, j)$ 的状态总数为 $C(n, 2)$ 。

假设状态 $S(i, j)$ 下 $h[i] < h[j]$ ,在向内移动短板至 $S(i + 1, j)$ ,则相当于消去了 ${S(i, j - 1), S(i, j - 2), … , S(i, i + 1)}$ 状态集合。而所有消去状态的面积一定都小于当前面积(即 $< S(i, j)$),因为这些状态:

  • 短板高度:相比 $S(i, j)$ 相同或更短(即 $\leq h[i]$ );

  • 底边宽度:相比 $S(i, j)$ 更短;

因此,每轮向内移动短板,所有消去的状态都 不会导致面积最大值丢失 ,证毕。

<Picture1.png,Picture2.png,Picture3.png,Picture4.png,Picture5.png,Picture6.png,Picture7.png,Picture8.png>

复杂度分析:

  • 时间复杂度 $O(N)$​ : 双指针遍历一次底边宽度 $N$​​ 。

  • 空间复杂度 $O(1)$​ : 变量 $i$ , $j$ , $res$ 使用常数额外空间。

代码:

[]
class Solution: def maxArea(self, height: List[int]) -> int: i, j, res = 0, len(height) - 1, 0 while i < j: if height[i] < height[j]: res = max(res, height[i] * (j - i)) i += 1 else: res = max(res, height[j] * (j - i)) j -= 1 return res
[]
class Solution { public int maxArea(int[] height) { int i = 0, j = height.length - 1, res = 0; while(i < j) { res = height[i] < height[j] ? Math.max(res, (j - i) * height[i++]): Math.max(res, (j - i) * height[j--]); } return res; } }
[]
class Solution { public: int maxArea(vector<int>& height) { int i = 0, j = height.size() - 1, res = 0; while(i < j) { res = height[i] < height[j] ? max(res, (j - i) * height[i++]): max(res, (j - i) * height[j--]); } return res; } };

统计信息

通过次数 提交次数 AC比率
580236 930683 62.3%

提交历史

提交时间 提交结果 执行时间 内存消耗 语言

相似题目

题目 难度
接雨水 困难
上一篇:
10-正则表达式匹配(Regular Expression Matching)
下一篇:
12-整数转罗马数字(Integer to Roman)
本文目录
本文目录